#region usings
using System;
using System.ComponentModel.Composition;

using XLreader;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

/*
									Only works with the custom DLL : XLReader

									VTH1618 _ Octobre 2015
									Vincent Thévenet
*/


namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "ExcelReader1", Category = "Value", Help = "I need somebody. Help .... ", Tags = "")]
	#endregion PluginInfo
	
	public class ValueExcelReader1Node : IPluginEvaluate
	{
		#region fields & pins
		
		[Input("workbook",StringType = StringType.Filename ,IsSingle = true)]
		public ISpread<string> xlfile;
		
		[Input("Sheet", DefaultValue = 1.0)]
		public ISpread<int> xlsheet;
		
		[Input("Row", DefaultValue = 1.0)]
		public ISpread<int> row;
		
		[Input("Clmn", DefaultValue = 1.0)]
		public ISpread<int> clmn;
		
		[Input("Read", DefaultValue = 0)]
		public ISpread<bool> xlread;
				
		[Output("Output")]
		public ISpread<string> FOutput;
		
		[Import()]
		public ILogger FLogger;
		#endregion fields & pins
	

		
			
		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			FOutput.SliceCount = SpreadMax;
			string filename = @xlfile[0];
				
			if(xlread[0])
            {            	
	            int xlsh = xlsheet[0];
	            int[] xlrow = new int[SpreadMax];
	            int[] xlcol = new int[SpreadMax];	
	                                 	
				for (int i =0; i < SpreadMax; i++)
	            	{	            		
	            		xlrow[i] = row[i%row.SliceCount];
	            		xlcol[i] = clmn[i%clmn.SliceCount];            		
	            	}
	            	
	            string[] Xlout = XLreader.ReadXlClass.ReadXl(filename,xlsh,xlrow,xlcol,SpreadMax);
            	
	            for (int i =0; i < SpreadMax; i++)
	            	{FOutput[i] = Xlout[i];}	
            }
			
			//FLogger.Log(LogType.Debug, "hi tty!");
		}		
	}
}
